#include <fstream>
#include <string>

ifstream file ("lcd.in");

char str [120][30];
int bitlist [10];
int gx;
int s;

void init ()
{
  bitlist [0] = 1 + 2 + 4 + 16 + 32 + 64;
  bitlist [1] = 4 + 32;
  bitlist [2] = 1 + 4 + 8 + 16 + 64;
  bitlist [3] = 1 + 4 + 8 + 32 + 64;
  bitlist [4] = 2 + 4 + 8 + 32;
  bitlist [5] = 1 + 2 + 8 + 32 + 64;
  bitlist [6] = 1 + 2 + 8 + 16 + 32 + 64;
  bitlist [7] = 1 + 4 + 32;
  bitlist [8] = 1 + 2 + 4 + 8 + 16 + 32 + 64;
  bitlist [9] = 1 + 2 + 4 + 8 + 32 + 64;
}

void vline (int x, int yb, int ye) 
{
  for (int i = yb; i < ye; i++) {
    str [x + gx][i] = '|';
  }
}

void hline (int xb, int xe, int y) 
{
  for (int i = xb; i < xe; i++)
    str [i + gx][y] = '-';
}

void paintbitlist (int v) {
  if (v & 1)
    hline (1, s+1, 0);
  if (v & 2)
    vline (0, 1, s+1);
  if (v & 4)
    vline (s + 1, 1, s+1);
  if (v & 8)
    hline (1, s+1, s + 1);
  if (v & 16)
    vline (0, s + 2, s + s + 2);
  if (v & 32)
    vline (s + 1, s + 2, s + s + 2);
  if (v & 64)
    hline (1, s+1, s + s + 2);
  gx += s + 3;
}

void paintstr ()
{
  for (int y = 0; y < 2*s + 3; y++) {
    for (int x = 0; x < gx - 1; x++) {
      cout << str [x][y];
    }
    cout << endl;
  }
  cout << endl;
}

void clear ()
{
  for (int x = 0; x < 120; x++)
    for (int y = 0; y < 30; y++) {
      str [x][y] = ' ';
    }
}

main ()
{
  init ();
  string zahl;
  while (1) {
    gx = 0;
    file >> s;
    if (s == 0)
      break;
    file >> zahl;

    int i = 0;
    clear ();
    while (i < zahl.length ()) {
      paintbitlist (bitlist [zahl [i] - '0']);
      i++;
    }
    paintstr ();
  }
  return 0;
}
