#include <fstream.h>

ifstream file ("maze.in");
int w, h;
char grid [400][400];

void hline (int x, int y, int x2) 
{
  x += x;
  y += y;
  x2 += x2;
  while (x <= x2) {
    grid [x++][y] = '*';
  }
}
void vline (int x, int y, int y2) 
{
  x+=x;
  y+=y;
  y2+=y2;
  while (y <= y2) 
    grid [x][y++] = '*';
}
int depth (int x, int y)
{
  int c = 0;
  int f = 0;
  while (1) {
    c++;
    grid [x][y] = '#';
    if (grid [x + 1][y] == '+')
      f = 1;
    else if (grid [x - 1][y] == '+')
      f = 1;
    else if (grid [x][y+1] == '+')
      f = 1;
    else if (grid [x][y-1] == '+')
      f = 1;
    
    if (grid [x + 1][y] == ' ')
      x++;
    else if (grid [x-1][y] == ' ')
      x--;
    else if (grid  [x][y+1] == ' ')
      y++;
    else if (grid [x][y-1] == ' ')
      y--;
    else 
      break;    
  }
  if (f == 1)
    return -1;
  return c;
}

main ()
{
  int x, y;
  int m = 0;
  while (1){
    file >> w >> h;
    if (w == 0 && h == 0) 
      break;
    for (x = 0; x < 400; x++) 
      for (y = 0; y < 400; y++) {
	grid [x][y] = ' ';
	if (x - y <= -h -h) 
	  grid [x][y] = '+';
	if (x - y >= h + h)
	  grid [x][y] = '+';
	if (x + y <= h + h+ 4)
	  grid [x][y] = '+';
	if (x + y >= h+ h+w+w+w+w+4)
	  grid [x][y] = '+';
      }
    for (int i = 0; i < h; i++) {
      x = h +1 - i;
      y = i + 1;
      for (int j = 0; j < w; j++) {
	char ch;
	file >> ch;
	if (ch == '/')
	  hline (x - 1, y + 1, x + 1);
	else if (ch == '\\') 
	  vline (x, y, y + 2);
	
	x += 1;
	y += 1;
      }
    }
    int d = -1;
    int l = 0;
    for (x = 0; x < 400; x++) 
      for (y = 0; y < 400; y++) {
	if (grid [x][y] == ' ') {
	  int s1 = depth (x, y);
	  depth (x, y);
	  if (s1 > 0) {
	    l++;
	  }
	  if (s1 > d)
	    d = s1;
	}
      }
    cout << "Maze #" << ++m << ":" << endl;
    if (l > 0) {
      cout << l << " Cycles; the longest has length " << d / 2<< "." << endl;
    } else
      cout << "There are no cycles." << endl;
    cout << endl;
    /*    cout << w << " " << h << endl;
    for (int yy = 0; yy < (w + h + 2) * 2; yy++) {
      for (int xx = 0; xx < (w + h + 2) * 2; xx++)
	cout << grid [xx][yy];
	cout << endl;
	}*/
  }
  return 0;
}
