#include <stdio.h>

#define oo 1000000000

int a[12000][10], q[12000], qa, qe, n, n1;

int distance(int x, int y) {
  int v, d[12000], u, i;

  for (v=0; v<n; v++) d[v] = oo;
  d[x] = 0;
  qa = qe = 0; q[0] = x;
  while (qe >= qa) {
    u = q[qa++];
    for (i=0; i<a[u][0];i++) {
      v = a[u][i+1];
      if (d[v] == oo) {
	if (u+n1 != v && v+n1 != u)
	  d[v] = d[u] + 1;
	else
	  d[v] = d[u];
	q[++qe] = v;
      }
    }
  }
  if (d[y] == oo) return -1;
  else return d[y];
}

int main(void) {
  FILE *in = fopen("game.in", "r");
  int w, h, i, j, i1, j1, x1 ,x2 ,y1 ,y2, kase=1, pair, dist;
  char s[100][100];

  while(1) {
    fscanf(in, " %d %d ", &w, &h);
    if (w == 0 && h == 0) break;

    n1 = w*h; n = 2*n1;
    printf("Board #%d:\n", kase++);
    pair=1;

    for (i = 0; i<h;i++)
      fgets(s[i], 100, in);

    for (i=0;i<n;i++)
	a[i][0]=0;

    for (i=0;i<w;i++)
      for (j=0;j<h;j++) {
	i1 = i+1; j1=j+1;
	if (i1 == w) i1=0;
	if (j1 == h) j1=0;
	if (s[j][i] == ' ') {
	  a[i+j*w][++a[i+j*w][0]] = i+j*w+n1;
	  /* a[i+j*w+n1][++a[i+j*w+n1][0]] = i+j*w; */
	}
	if (s[i][j] != s[i1][j]) {
	  a[i+j*w+n1][++a[i+j*w+n1][0]] = i1+j*w;
	  /* a[i1+j*w][++a[i1+j*w][0]] = i+j*w+n1; */
	  /* a[i+j*w][++a[i+j*w][0]] = i1+j*w+n1; */
	  a[i1+j*w+n1][++a[i1+j*w+n1][0]] = i+j*w;
	}
	if (s[i][j] != s[i][j1]) {
	  /* a[i+j*w][++a[i+j*w][0]] = i+j1*w+n1; */
	  a[i+j1*w+n1][++a[i+j1*w+n1][0]] = i+j*w;
	  a[i+j*w+n1][++a[i+j*w+n1][0]] = i+j1*w;
	  /* a[i+j1*w][++a[i+j1*w][0]] = i+j*w+n1; */
	}
      }

    while (1) {
      fscanf(in, " %d %d %d %d ", &x1, &y1, &x2, &y2);
      if (x1 == 0 && x2 == 0 && y1 == 0 && y2 == 0) break;
      /*
      dist = -1;
      
      if (x1 == x2) {
	if (y1 > y2 && ((y1 - y2) == 1||(y1-y2)==(h-1))) dist = 1;
	if (y2 > y1 && ((y2-y1)==1||(y2-y1)==(h-1))) dist = 1;
      }
      else if (y1 == y2) {
	if (x1 > x2 && ((x1-x2)==1||(x1-x2)==(w-1))) dist=1;
	if (x2 > x1 && ((x2-x1)==1||(x2-x1)==(w-1))) dist=1;
      }
      if (dist==1) {
	printf("Pair %d: 1 segments.\n", pair++);
	continue;
      }
      */
      dist = distance((x1-1)+(y1-1)*w+n1,(x2-1)+(y2-1)*w);
      if (dist < 0) printf("Pair %d: impossible.\n", pair++);
      else printf("Pair %d: %d segments.\n", pair++, dist);
    }
    printf("\n");
  }

  return 0;
}
