#include <fstream>
#include <queue>

#define oo 1000000
#define off 100000

ifstream file ("game.in");
int w, h;
int field [100][100];
int hor [100][100];
int ver [100][100];
int x, y;
typedef pair<int, int> Pair;
queue<Pair > q, q1;
int xb, yb, xe, ye;
int end;

void seth (int x, int y, int v, queue<Pair> &q) 
{
  if (x < 0 || y < 0 || x > w+1 || y > h+1)
    return;
  if (hor [x][y] > v) {
    if ((x == xe && y == ye) || field [x][y] == 0) {
      q.push (Pair (x, y-off));
      hor [x][y] = v;
    }
  }
}

void setv (int x, int y, int v, queue<Pair> &q)
{
  if (x < 0 || y < 0 || x > w + 1 || y > h+1)
    return;
  if (ver [x][y] > v) {
    if ((x == xe && y == ye) && field [x][y] == 0) {
      q.push (Pair (x, y));
      ver [x][y] = v;
    }
  }   
}

int main ()
{
  char s [100];
  int c;
  while (1) {
    file >> w >> h;
    if (w == 0 && h == 0)
      break;
    file.getline (s, 100);
    for (x = 0; x < 100; x++)
      for (y = 0; y < 100; y++)
	field [x][y] = 0;

    for (int i = 0; i < h; i++) {
      file.getline (s, 100);
      for (int j = 0; j < w; j++) {      
	if (s [j] == ' ')
	  field [j+1][i+1] = 0;
	else
	  field [j+1][i+1] = 1;
      }
    }    
    /*    for (y = 0; y < h; y++) {
      for (x = 0; x < w; x++)
      cout << field [x][y];
      cout << endl;
      } */   
    while (1) {
      c = 0;
      file >> xb >> yb >> xe >> ye;
      if (xb == 0 && yb == 0 && xe == 0 && ye == 0)
	break;
      
      for (x = 0; x < 100; x++)
	for (y = 0; y < 100; y++)
	  hor [x][y] = ver [x][y] = oo;

      hor [xb][yb] = 0;
      ver [xb][yb] = 0;
      q.push (Pair(xb, yb));
      q.push (Pair(xb ,yb-off));

      Pair p;
      end = 0;
      while (q.size () > 0) {
	while (q.size () > 0) {
	  p = q.front ();	
	  q.pop ();
	  
	  if (p.second < 0) { // horizontal
	    x = p.first;
	    y = p.second + off;
	    cout << x << " " << y << endl;
	    seth (x + 1, y, hor [x][y], q);
	    seth (x - 1, y, hor [x][y], q);
	    setv (x, y + 1, hor [x][y]+1, q1);
	    setv (x, y - 1, hor [x][y]+1, q1);
	  } else { // vert
	    x = p.first;
	    y  =p.second;
	    cout << x << " " << y << endl;
	    setv (x, y + 1, ver [x][y] ,q);
	    setv (x, y - 1, ver [x][y], q);
	    seth (x + 1, y, ver [x][y] + 1, q1);
	    seth (x - 1, y, ver [x][y] + 1, q1);
	  }
	  if (end)
	    break;
	}
	cout << endl;
      if (end)
	  break;

	q = q1;
	c++;
	while (q1.size ()>0)
	  q1.pop ();
      }
      if(end == 0)
	cout << "Impossible" << endl;
      else
	cout << c << endl;

    }
  }
  
  return 0;
}
