#include <iostream>
#include <fstream>

int main() {
  ifstream file("robbery.in");

  bool view[102][102][102];
  bool test[102][102][102];
  bool test2[102][102][102];
  int state[102];
  int fx[102],fy[102];

  int W,H,t,n,N=1;
  
  int x1,y1,x2,y2;
  int i,ti,y,x,xi,yi;

  bool lost;

  while (true) {
  

    file >> W >> H >> t;
    // cout << "********"<< " " << W << " "<< H<< " " << t<< " " << endl;

    if (W==0 && H==0 && t==0) break;

    // init
    for (ti=1;ti<=t;ti++) {
      for (x=0;x<=W+1;x++)
	for (y=0;y<=H+1;y++)
	  //if (x==0 || y==0 || x==101 || y==101) t[ti][x][y]=false;  
	  //else t[ti][x][y]=true; 
	  view[ti][x][y]=false;  
    }

    
    // read
    file >> n;
    for (i=0;i<n;i++) {
      file >> ti >> x1 >> y1 >> x2 >> y2;
      for (x=x1;x<=x2;x++)
	for (y=y1;y<=y2;y++)
	  view[ti][x][y]=true;
    }
    

    // do - init
    for (x=0;x<=W+1;x++)
      for (y=0;y<=H+1;y++)
	if (x==0 || y==0 || x==W+1 || y==H+1) test[ti][x][y]=false;  
	else test[0][x][y]=true; 
  
  
    lost=false;


    for (ti=1;ti<=t;ti++) {
      state[ti]=0; // lost
      for (x=0;x<=W+1;x++) {
	for (y=0;y<=H+1;y++) {
	  
	  if (x==0 || y==0 || x==W+1 || y==H+1)  {
	    test[ti][x][y]=false;  
	    continue;
	  }
	  
	  // ----
	  test[ti][x][y]=false;
	  if (!view[ti][x][y]) {
	    yi=0;
	    for (xi=-1; xi<=1; xi++) {
	      test[ti][x][y] = test[ti][x][y] || test[ti-1][x+xi][y+yi];
	    }
	    xi=0;
	    for (yi=-1; yi<=1; yi++) {
	      test[ti][x][y] = test[ti][x][y] || test[ti-1][x+xi][y+yi];
	    }
	  }
	  // ----
	  if (test[ti][x][y]) {
	    state[ti]++;
	    fx[ti]=x;
	    fy[ti]=y;
	  }
	  
	}
      }

      if (state[ti]==0) {
	lost=true;
	break;
      }


    }

    // back
    for (x=0;x<=W+1;x++)
      for (y=0;y<=H+1;y++)
	test2[t][x][y]=test[t][x][y]; 


    if (!lost) for (ti=t-1;ti>=1;ti--) {
      state[ti]=0; // lost
      for (x=0;x<=W+1;x++) {
	for (y=0;y<=H+1;y++) {
	  
	  if (x==0 || y==0 || x==W+1 || y==H+1)  {
	    test2[ti][x][y]=false;  
	    continue;
	  }
	  
	  // ----
	  test2[ti][x][y]=false;
	  if (!view[ti][x][y] && test[ti][x][y]) {
	    yi=0;
	    for (xi=-1; xi<=1; xi++) {
	      test2[ti][x][y] = test2[ti][x][y] || test2[ti+1][x+xi][y+yi];
	    }
	    xi=0;
	    for (yi=-1; yi<=1; yi++) {
	      test2[ti][x][y] = test2[ti][x][y] || test2[ti+1][x+xi][y+yi];
	    }
	  }
	  // ----
	  if (test2[ti][x][y]) {
	    state[ti]++;
	    fx[ti]=x;
	    fy[ti]=y;
	  }
	  
	}
      }
    }
    
    cout << "Robbery #" << N++ << ":" << endl;
    if (lost) {
      cout << "The robber has escaped." << endl;
    }
    else {
      int count=0;
      for (ti=1;ti<=t;ti++) {
	if (state[ti]==1) {
	  cout << "Time step " << ti << ": " 
	    << "The robber has been at "
	       << fx[ti] << "," << fy[ti] << "." << endl;
	  count++;
	}
      }
      if (count==0) {
	cout << "Nothing known." << endl;
      }
    }
    cout << endl;
  
  }

}
